"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Lab B: a simple event-driven graphics game

  (starter file - remove this line once edited)
  <YOUR NAMES GO HERE>
-----------------------------------------------
"""


# ... from random import ...

from grid_graphics import (open_window, paint, unpaint, event_loop,
                           set_click_handler, set_key_handler, set_timer,
                           close_window)


# constants - adjust as you see fit (particularly for #9)
ROWS = 20
COLUMNS = 30
BG_COLOR = 'gray'
GOLD_COLOR = 'gold'
PLAYER_COLOR = 'green'
GAME_TIME = 25   # seconds
ENEMY_DELAY = 500   # milliseconds
ENEMY_COLOR = 'red'
# ...

# global variables
_game_on = True
_time = GAME_TIME
_player = (0, 0)
_gold = (COLUMNS - 1, ROWS - 1)
_enemy = (COLUMNS // 2, ROWS // 2)
# ...


# 6.
def play():
    reset()
    open_window(columns=COLUMNS, rows=ROWS, bgcolor=BG_COLOR,
                title='a simple game')
    paint(_player, PLAYER_COLOR)
    paint(_gold, GOLD_COLOR)
    set_key_handler(key_handler)
    countdown_timer()
    # ...
    event_loop()


def reset():
    global _player, _gold, _enemy, _game_on, _time   # ...
    _game_on = True
    _time = GAME_TIME
    _player = (0, 0)
    _gold = (COLUMNS - 1, ROWS - 1)
    _enemy = (COLUMNS // 2, ROWS // 2)
    # ...


# 2.
def key_handler(key):
    if key == 'Right':
        player_move(1, 0)
    # ...
    elif key == 'q':
        game_over('you quit')


# 3, 8.
def player_move(dc, dr):
    """Adjusts player location by dc columns and dr rows."""
    global _player
    (c, r) = _player
    c += dc
    r += dr
    if 0 <= c and c < COLUMNS and 0 <= r and r < ROWS:
        unpaint(_player)
        _player = (c, r)
        paint(_player, PLAYER_COLOR)
        # ...


# 4, 5.
def countdown_timer():
    global _time
    if _game_on:
        ...


# 6, 7, 8, 9
def enemy_timer():
    global _enemy
    if _game_on:
        ...
        paint(_enemy, ENEMY_COLOR)
        ...


def game_over(msg):
    close_window()
    print('game over: ' + msg)
    # ...


# ...


if __name__ == '__main__':
    play()
