"""
Introduction to Computer Programming

whacka-whatever

simple game illustrating basic interplay of:

  timer events
  mouse-click handling
  key-press handling
  global variables

"""

from random import randrange

from grid_graphics import (open_window, paint, clear, event_loop,
                           set_click_handler, set_key_handler, set_timer,
                           close_window)


DELAY = 1000   # milliseconds
COLUMNS = 40
ROWS = 20
TARGET_COLOR = 'pink'


_running = True
_score = 0
_target = None  # pair representing current location of target


def play():
    open_window(columns=COLUMNS, rows=ROWS, title='Whacka-Whatever')
    set_click_handler(click_action)
    set_key_handler(key_action)
    set_timer(timer_action, DELAY)
    event_loop()
    print(f'final score = {_score}')


def key_action(k):
    global _running
    if k == 'space':
        _running = not _running
    elif k == 'q':
        _running = False
        close_window()


def timer_action():
    global _target
    if _running:
        clear()
        _target = (randrange(COLUMNS), randrange(ROWS))
        paint(_target, TARGET_COLOR)
    set_timer(timer_action, DELAY)


def click_action(p):
    global _score
    if _running:
        if p == _target:
            _score += 1


if __name__ == '__main__':
    play()
